package lcsb.mapviewer.annotation.services;

import java.util.Collection;
import java.util.List;

import lcsb.mapviewer.annotation.cache.Cacheable;
import lcsb.mapviewer.annotation.data.MiRNA;
import lcsb.mapviewer.model.Project;
import lcsb.mapviewer.model.map.MiriamData;

/**
 * Class used for accessing and parsing data from MiRNA database.
 * 
 * @author Ayan Rota
 * 
 */
public interface MiRNAParser extends IExternalService, Cacheable {

  List<MiRNA> getMiRnasByNames(final Collection<String> names) throws MiRNASearchException;

  List<String> getSuggestedQueryList(final Project project) throws MiRNASearchException;

  List<MiRNA> getMiRnaListByTargets(final Collection<MiriamData> targetsMiriam) throws MiRNASearchException;
}
