package lcsb.mapviewer.converter.model.sbml;

import org.junit.runner.RunWith;
import org.junit.runners.Suite;
import org.junit.runners.Suite.SuiteClasses;

import lcsb.mapviewer.converter.model.sbml.compartment.AllCompartmentTests;
import lcsb.mapviewer.converter.model.sbml.reaction.AllSbmlReactionParserTests;
import lcsb.mapviewer.converter.model.sbml.species.AllSbmlSpeciesTests;
import lcsb.mapviewer.converter.model.sbml.units.UnitMappingTest;

@RunWith(Suite.class)
@SuiteClasses({ AllCompartmentTests.class,
    AllSbmlReactionParserTests.class,
    AllSbmlSpeciesTests.class,
    GenericSbmlParserTest.class,
    GenericSbmlToXmlParserTest.class,
    CellDesignerToMultiExportTest.class,
    CopasiImportTest.class,
    ElementPropertiesExport.class,
    ElementPropertiesExportToMultiTest.class,
    ElementPropertiesExportToLayoutTest.class,
    GeneratedSbmlValidationTests.class,
    MultiParserTest.class,
    ReactionPropertiesExportToMultiTest.class,
    SbmlBioEntityParserTest.class,
    SbmlElementParserTest.class,
    SbmlExporterTest.class,
    SbmlExporterFromCellDesignerTest.class,
    SbmlModelUtilsTest.class,
    SbmlPareserForInvalidReactionTest.class,
    SbmlParserTest.class,
    SbmlValidationTests.class,
    UnitMappingTest.class,
})
public class AllSbmlConverterTests {

}
