package lcsb.mapviewer.converter.model.sbml.reaction;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import org.junit.Test;
import org.sbml.jsbml.ModifierSpeciesReference;

import lcsb.mapviewer.converter.model.sbml.SbmlExporter;
import lcsb.mapviewer.converter.model.sbml.SbmlTestFunctions;
import lcsb.mapviewer.model.map.reaction.Modifier;

public class SBOTermModifierTypeTest extends SbmlTestFunctions {

  @Test
  public void testUnknownId() {
    ModifierSpeciesReference reference = new ModifierSpeciesReference(SbmlExporter.SUPPORTED_VERSION, SbmlExporter.SUPPORTED_LEVEL);
    reference.setSBOTerm("SBO:0000000");
    Class<? extends Modifier> clazz = SBOTermModifierType.getTypeSBOTerm(reference);
    assertNotNull(clazz);
    assertEquals(1, super.getWarnings().size());
    assertNotNull(super.getWarnings().get(0).getMarker());
  }

}
