package lcsb.mapviewer.modelutils.serializer.model.map.layout;

import java.io.IOException;
import java.util.function.Function;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;

import lcsb.mapviewer.model.map.layout.ReferenceGenomeGeneMapping;

public class ReferenceGenomeGeneMappingSerializer extends JsonSerializer<ReferenceGenomeGeneMapping> {

  private Function<String, String> getLocalUrl;

  public ReferenceGenomeGeneMappingSerializer(final Function<String, String> getLocalUrl) {
    this.getLocalUrl = getLocalUrl;
  }

  @Override
  public void serialize(final ReferenceGenomeGeneMapping mapping, final JsonGenerator gen,
      final SerializerProvider serializers)
      throws IOException {
    gen.writeStartObject();
    gen.writeNumberField("downloadProgress", mapping.getDownloadProgress());
    gen.writeStringField("localUrl", getLocalUrl.apply(mapping.getSourceUrl()));
    gen.writeStringField("sourceUrl", mapping.getSourceUrl());
    gen.writeStringField("name", mapping.getName());
    gen.writeNumberField("idObject", mapping.getId());
    gen.writeEndObject();

  }
}