package lcsb.mapviewer.modelutils.serializer.model.map.layout;

import java.io.IOException;
import java.util.function.Function;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;

import lcsb.mapviewer.model.map.layout.ReferenceGenome;

public class ReferenceGenomeSerializer extends JsonSerializer<ReferenceGenome> {

  private Function<String, String> getLocalUrl;

  public ReferenceGenomeSerializer(final Function<String, String> getLocalUrl) {
    this.getLocalUrl = getLocalUrl;
  }

  @Override
  public void serialize(final ReferenceGenome genome, final JsonGenerator gen,
      final SerializerProvider serializers)
      throws IOException {
    gen.writeStartObject();
    
    gen.writeObjectField("organism", genome.getOrganism());
    gen.writeStringField("version", genome.getVersion());
    gen.writeObjectField("type", genome.getType());
    gen.writeNumberField("downloadProgress", genome.getDownloadProgress());
    gen.writeStringField("sourceUrl", genome.getSourceUrl());
    gen.writeStringField("localUrl", getLocalUrl.apply(genome.getSourceUrl()));
    gen.writeNumberField("idObject", genome.getId());
    gen.writeObjectField("geneMapping", genome.getGeneMapping());
    gen.writeEndObject();

  }
}