package lcsb.mapviewer.persist;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.annotation.Rollback;
import org.springframework.transaction.annotation.Transactional;

import lcsb.mapviewer.model.user.User;
import lcsb.mapviewer.persist.dao.user.UserDao;

@Transactional
@Rollback(true)
public abstract class PersistTestFunctions extends PersistTestFunctionsNoTransaction {

  protected static Logger logger = LogManager.getLogger();

  @Autowired
  protected UserDao userDao;

  protected User createUser() {
    User user = new User();
    user.setName("John");
    user.setSurname("Doe");
    user.setEmail("john.doe@uni.lu");
    user.setLogin("john.doe");
    user.setCryptedPassword("passwd");
    userDao.add(user);
    return user;
  }

}
