package lcsb.mapviewer.persist.dao.map.kinetics;

import static org.junit.Assert.assertEquals;

import java.util.Arrays;
import java.util.List;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import lcsb.mapviewer.model.map.kinetics.SbmlParameter;
import lcsb.mapviewer.model.map.model.Model;
import lcsb.mapviewer.model.map.model.ModelFullIndexed;
import lcsb.mapviewer.persist.PersistTestFunctions;
import lcsb.mapviewer.persist.dao.map.ModelDao;

public class SbmlParameterDaoTest extends PersistTestFunctions {

  @Autowired
  private ModelDao modelDao;
  
  @Autowired
  private SbmlParameterDao sbmlParameterDao;

  @Test
  public void testGetByMaps() {
    Model model = new ModelFullIndexed(null);
    SbmlParameter parameter = new SbmlParameter("id");
    model.addParameter(parameter);

    modelDao.add(model);
    
    List<SbmlParameter> parameters = sbmlParameterDao.getByMaps(Arrays.asList(model.getModelData()));
    assertEquals(1, parameters.size());
  }

  @Test
  public void testGetById() {
    Model model = new ModelFullIndexed(null);
    SbmlParameter parameter = new SbmlParameter("id");
    model.addParameter(parameter);

    modelDao.add(model);
    
    SbmlParameter result = sbmlParameterDao.getById(parameter.getId(), model.getModelData());
    assertEquals(parameter, result);
  }

}
