package lcsb.mapviewer.api;

import java.util.List;

import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

@JsonSerialize(using = CustomPageSerializer.class)
@JsonDeserialize(using = CustomPageDeserialize.class)
public class CustomPage<T> extends PageImpl<T> {

  @JsonProperty("filteredSize")
  private long filtered;

  public CustomPage(final List<T> content) {
    super(content);
  }

  public CustomPage(final List<T> content, final Pageable pageable, final long total) {
    super(content, pageable, total);
    this.filtered = total;
  }

  public CustomPage(final List<T> content, final Pageable pageable, final long total, final long filtered) {
    super(content, pageable, total);
    this.filtered = filtered;
  }

  /**
   * 
   */
  private static final long serialVersionUID = 1L;

  public long getFiltered() {
    return filtered;
  }

}
