package lcsb.mapviewer.api.projects;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import lcsb.mapviewer.model.Project;

@JsonSerialize(using = ProjectSerializer.class)
public class ProjectDTO extends Project {

  private static final long serialVersionUID = 1L;

  @JsonProperty
  private boolean sharedInMinervaNet;

  public ProjectDTO(final Project project, final boolean sharedInMinervaNet) {
    this(project);
    this.sharedInMinervaNet = sharedInMinervaNet;
  }

  private ProjectDTO(final Project project) {
    this.setId(project.getId());
    this.setProjectId(project.getProjectId());
    this.setDisease(project.getDisease());
    this.setName(project.getName());
    this.setVersion(project.getVersion());
    this.setOwner(project.getOwner());
    this.setNotifyEmail(project.getNotifyEmail());
    this.setDirectory(project.getDirectory());
    this.setStatus(project.getStatus());
    this.setProgress(project.getProgress());
    this.setLogEntries(project.getLogEntries());
    this.setMapCanvasType(project.getMapCanvasType());
    this.setGoogleMapLicenseAcceptDate(project.getGoogleMapLicenseAcceptDate());
    this.setCreationDate(project.getCreationDate());
    if (project.getTopModelData() != null) {
      this.setTopModel(project.getTopModelData());
    }
    this.setModels(project.getModels());
    this.setProjectBackgrounds(project.getProjectBackgrounds());
    this.setDataOverlays(project.getDataOverlays());
    this.setInputData(project.getInputData());
    this.setOrganism(project.getOrganism());
    this.setSbgnFormat(project.isSbgnFormat());
    this.setOverviewImages(project.getOverviewImages());
    this.setGlyphs(project.getGlyphs());
  }

  public boolean isSharedInMinervaNet() {
    return sharedInMinervaNet;
  }

  public void setSharedInMinervaNet(final boolean sharedInMinervaNet) {
    this.sharedInMinervaNet = sharedInMinervaNet;
  }

}
