package lcsb.mapviewer.services.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import lcsb.mapviewer.annotation.services.MiriamConnector;
import lcsb.mapviewer.annotation.services.PubmedParser;
import lcsb.mapviewer.annotation.services.PubmedSearchException;
import lcsb.mapviewer.model.Article;
import lcsb.mapviewer.model.map.MiriamData;
import lcsb.mapviewer.services.interfaces.IMiriamService;

@Transactional
@Service
public class MiriamService implements IMiriamService {

  private MiriamConnector miriamConnector;

  private PubmedParser pubmedParser;

  @Autowired
  public MiriamService(final MiriamConnector miriamConnector, final PubmedParser pubmedParser) {
    this.miriamConnector = miriamConnector;
    this.pubmedParser = pubmedParser;
  }

  @Override
  public String getUrlString(final MiriamData miriamData) {
    return miriamConnector.getUrlString(miriamData);
  }

  @Override
  public Article getArticle(final MiriamData miriamData) throws PubmedSearchException {
    return pubmedParser.getPubmedArticleById(miriamData.getResource());
  }
}
