package lcsb.mapviewer.services.interfaces;

import java.util.List;
import java.util.Map;

import lcsb.mapviewer.model.map.MiriamType;
import lcsb.mapviewer.model.map.species.Element;
import lcsb.mapviewer.persist.dao.map.species.ElementProperty;
import lcsb.mapviewer.services.ObjectNotFoundException;
import lcsb.mapviewer.services.QueryException;

public interface IElementService {

  Element getById(final int id);

  Element getElementById(final String projectId, final int elementId) throws ObjectNotFoundException;

  Element getElementById(final String projectId, final int mapId, final int elementId) throws QueryException;

  List<Element> getElementsByFilter(Map<ElementProperty, List<? extends Object>> properties);
  
  List<Element> getElementsByFilter(Map<ElementProperty, List<? extends Object>> properties, final boolean initializeLazy);

  Map<MiriamType, Integer> getAnnotationStatistics(final String projectId, final String mapId) throws QueryException;

}
