package lcsb.mapviewer.services.interfaces;

import java.util.List;
import java.util.Map;
import java.util.Set;

import org.springframework.data.domain.Page;

import lcsb.mapviewer.model.map.MiriamType;
import lcsb.mapviewer.model.map.kinetics.SbmlParameter;
import lcsb.mapviewer.model.map.reaction.Reaction;
import lcsb.mapviewer.persist.dao.map.ReactionProperty;
import lcsb.mapviewer.services.QueryException;

public interface IReactionService {

  Reaction getById(final int id);

  Reaction getReactionById(final String projectId, final int mapId, final int elementId) throws QueryException;

  List<Reaction> getReactionById(final String projectId, final String modelId, final Set<Integer> ids, final Set<Integer> participantIds)
      throws QueryException;

  List<SbmlParameter> getParameters(final String projectId, final String modelId) throws QueryException;

  Map<MiriamType, Integer> getAnnotationStatistics(final String projectId, final String mapId) throws QueryException;

  Page<Reaction> getReactionsByFilter(Map<ReactionProperty, List<? extends Object>> reactionSearch, final boolean initializeLazy);
}
