package lcsb.mapviewer.web.bean.utils;

import java.sql.SQLException;

import javax.transaction.Transactional;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import lcsb.mapviewer.persist.DbUtils;

@Component
public class AutoVacuumBean {

  private final transient Logger logger = LogManager.getLogger();

  private transient DbUtils dbUtils;

  @Autowired
  public AutoVacuumBean(
      final DbUtils dbUtils) {
    this.dbUtils = dbUtils;
  }

  @Transactional
  @Scheduled(cron = "0 15 2 * * ?")
  public void scheduleTaskUsingCronExpression() {
    try {
      logger.info("VACUUM started");
      dbUtils.vaccuum();
    } catch (SQLException e) {
      logger.error("Problem with vacuum", e);
    } finally {
      logger.info("VACUUM finished");
    }
  }
}
